﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 15.10.2020
 * Time: 01:30
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using HarmonyLib;
using RimWorld;
using Verse;

namespace RIMMSqol
{
	/// <summary>
	/// Description of Alert_Active.
	/// </summary>
	[HarmonyPatch(typeof(Alert))]
	[HarmonyPatch("get_Active")]
	[HarmonyPatchNamespace("HiddenAlerts")]
	public static class Alert_Active
	{
		public static bool Prepare() {
			if ( QOLMod.getSettings().hiddenAlerts == null ) QOLMod.getSettings().hiddenAlerts = new HashSet<string>();
			return true;
		}
		
		static void Postfix(Alert __instance, ref bool __result) {
			if ( __result ) {
				__result = !QOLMod.getSettings().hiddenAlerts.Contains(__instance.GetType().Name);
			}
		}
	}
}
