﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 14.02.2019
 * Time: 17:16
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Reflection;
using RimWorld;
using UnityEngine;
using Verse;

namespace RIMMSqol
{
	/// <summary>
	/// Description of Dialog_TradeForFree.
	/// </summary>
	public class Dialog_TradeForFree : Dialog_Trade {
		protected Func<List<Tradeable>,int> GetVersion;
		protected int cachedVersion;
		
		public Dialog_TradeForFree(Pawn playerNegotiator, ITrader trader, bool giftsOnly = false) : base(playerNegotiator,trader,giftsOnly) {
			GetVersion = UtilReflection.CreateGetter<List<Tradeable>,int>(typeof(List<Tradeable>).GetField("_version",BindingFlags.Instance|BindingFlags.NonPublic));
		}
		
		public override void PostOpen()
		{
			MakeTradeablesFree();
			base.PostOpen();
		}
		
		protected void MakeTradeablesFree() {
			FieldInfo fBuy = typeof(Tradeable).GetField("pricePlayerBuy",BindingFlags.Instance|BindingFlags.NonPublic);
			FieldInfo fSell = typeof(Tradeable).GetField("pricePlayerSell",BindingFlags.Instance|BindingFlags.NonPublic);
			foreach ( Tradeable tr in TradeSession.deal.AllTradeables ) {
				fBuy.SetValue(tr,0.00001f);
				fSell.SetValue(tr,0.00001f);
			}
			cachedVersion = GetVersion(TradeSession.deal.AllTradeables);
		}
		
		public override void DoWindowContents(Rect inRect) {
			if ( GetVersion(TradeSession.deal.AllTradeables) != cachedVersion ) {
				MakeTradeablesFree();
			}
			base.DoWindowContents(inRect);
		}
	}
}
