﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 05.04.2019
 * Time: 08:22
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using HarmonyLib;
using RIMMSqol.genericSettings;
using RimWorld;
using UnityEngine;
using Verse;

namespace RIMMSqol
{
	[HarmonyPatch(typeof(RimWorld.StatsReportUtility))]
	[HarmonyPatch("DrawStatsReport")]
	[HarmonyPatch(new[]{typeof(Rect),typeof(Thing)})]
	[HarmonyPatchNamespace("StatsReportEditShortcut")]
	public static class DrawStatsReport_EditShortcut
	{
		static bool Prefix(Rect rect, Thing thing) {
			if ( thing != null ) {
				ThingDef def = thing.def;
				ThingDef stuff = thing.Stuff;
				if ( def != null ) {
					SettingsProperties props;
					if ( def.category == ThingCategory.Building ) {
						props = SettingsStorage.getSettingsProperties("buildings");
					} else if ( def.category == ThingCategory.Pawn ) {
						props = SettingsStorage.getSettingsProperties("pawns");
					} else props = null;
					
					if ( props != null ) {
						Texture2D tex = Materials.iconEdit;
						Rect r = new Rect(rect.xMax - 24f, rect.yMin, 24f, 24f);
						if ( Widgets.ButtonImage(r,tex) ) {
							Dialog_ModSettings ms = new Dialog_ModSettings();
							ms.GetType().GetField("selMod",System.Reflection.BindingFlags.Instance|System.Reflection.BindingFlags.NonPublic|System.Reflection.BindingFlags.Public)
								.SetValue(ms,QOLMod.getModHandle());
							Find.WindowStack.Add(ms);
							QOLMod.NavigateToEditing(props, def);
							Verse.Sound.SoundStarter.PlayOneShotOnCamera(SoundDefOf.DialogBoxAppear,null);
						} else {
							TooltipHandler.TipRegion(r, () => "EditEntry".Translate(def.label), 1);
						}
					}
				}
				if ( stuff != null ) {
					SettingsProperties props = SettingsStorage.getSettingsProperties("material");
					if ( props != null ) {
						Texture2D tex = Materials.iconEdit;
						Rect r = new Rect(rect.xMax - 48f, rect.yMin, 24f, 24f);
						if ( Widgets.ButtonImage(r,tex) ) {
							Dialog_ModSettings ms = new Dialog_ModSettings();
							ms.GetType().GetField("selMod",System.Reflection.BindingFlags.Instance|System.Reflection.BindingFlags.NonPublic|System.Reflection.BindingFlags.Public)
								.SetValue(ms,QOLMod.getModHandle());
							Find.WindowStack.Add(ms);
							QOLMod.NavigateToEditing(props, stuff);
							Verse.Sound.SoundStarter.PlayOneShotOnCamera(SoundDefOf.DialogBoxAppear,null);
						} else {
							TooltipHandler.TipRegion(r, () => "EditEntry".Translate(stuff.label), 1);
						}
					}
				}
			}
			return true;
		}
	}
}
