﻿using HarmonyLib;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using Verse;

namespace RIMMSqol
{
    [HarmonyPatch(typeof(LetterStack))]
    [HarmonyPatch("ReceiveLetter")]
    [HarmonyPatch(new[] { typeof(Letter), typeof(string) })]
    [HarmonyPatchNamespace("HiddenAlerts")]
    public static class LetterStack_ReceiveLetter
    {
        static private List<string> hiddenLetters;

        static void Prepare()
        {
            QOLMod.addApplySettingsListener(mod =>
            {
                hiddenLetters = QOLMod.getSettings().hiddenLetters;
            });
            hiddenLetters = QOLMod.getSettings().hiddenLetters;
        }

        static bool Prefix(LetterStack __instance, Letter let)
        {
            if (!let.CanDismissWithRightClick) return true;
            if (hiddenLetters != null)
            {
                string label = let.label;
                if ( label != null )
                {
                    foreach (string labelExpression in hiddenLetters)
                    {
                        if ( Regex.IsMatch(label, labelExpression) )
                        {
                            return false;
                        }
                    }
                }
            }
            return true;
        }
    }
}
