﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 10.09.2018
 * Time: 10:51
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using HarmonyLib;
using RimWorld;
using Verse;

namespace RIMMSqol
{
	[HarmonyPatch(typeof(Pawn_TrainingTracker))]
	[HarmonyPatch("TrainingTrackerTickRare")]
	[HarmonyPatchNamespace("StopTamenessDecay")]
	static public class PreventTamenessDecay_Pawn_TrainingTracker_TrainingTrackerTickRare
	{
		static bool stopTamenessDecay = true;
		
		static bool Prepare() {
			QOLMod.addApplySettingsListener(mod=>stopTamenessDecay = QOLMod.stopTamenessDecay());
			stopTamenessDecay = QOLMod.stopTamenessDecay();
			return true;
		}
		
		[HarmonyPriority(Priority.First)]
		static void Prefix(DefMap<TrainableDef, int> ___steps, out DefMap<TrainableDef, int> __state) {
			if ( stopTamenessDecay ) {
				__state = new DefMap<TrainableDef, int>();
				foreach ( KeyValuePair<TrainableDef, int> kvp in ___steps ) {
					__state[kvp.Key] = kvp.Value;
				}
			} else {
				__state = null;
			}
		}
		
		static void Postfix(DefMap<TrainableDef, int> ___steps, DefMap<TrainableDef, int> __state) {
			if ( stopTamenessDecay ) {
				if ( __state == null ) {
					Log.Error("RIMMSqol detected a mod conflict on Pawn_TrainingTracker.TrainingTrackerTickRare which prevents the option \"Stop tameness decay\" from working. Deactivating it for now.");
					Log.Error(UtilHarmonyReporting.ReportPatchesOnMethod(typeof(Pawn_TrainingTracker), "TrainingTrackerTickRare"));
					stopTamenessDecay = false;
					return;
				}
				foreach ( KeyValuePair<TrainableDef, int> kvp in ___steps ) {
					___steps[kvp.Key] = __state[kvp.Key];
				}
			}
		}
	}
}
