﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 26.07.2019
 * Time: 08:06
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using HarmonyLib;
using RimWorld;
using Verse;

namespace RIMMSqol
{
	/// <summary>
	/// Description of ThingFilter_SetAllow_StuffCategoryDef.
	/// </summary>
	[HarmonyPatch(typeof(ThingFilter))]
	[HarmonyPatch("SetAllow")]
	[HarmonyPatch(new[]{typeof(StuffCategoryDef),typeof(bool)})]
	[HarmonyPatchNamespace("ThingFilterBugfix")]
	static class ThingFilter_SetAllow_StuffCategoryDef
	{
		static Func<ThingFilter,Action> ThingFilterSettingsChangedCallbackGet = UtilReflection.CreateGetter<ThingFilter,Action>(typeof(ThingFilter).GetField("settingsChangedCallback", UtilReflection.BindingInstanceFlags));
		
		[HarmonyPriority(Priority.Last)]
		static bool Prefix(ThingFilter __instance, StuffCategoryDef cat, bool allow) {
			foreach (ThingDef thingDef in DefDatabase<ThingDef>.AllDefsListForReading) {
				if (thingDef.IsStuff && thingDef.stuffProps.categories.Contains(cat)) {
					__instance.SetAllow(thingDef, allow);
				}
			}
			
			Action sccb = ThingFilterSettingsChangedCallbackGet(__instance);
			if (sccb != null) {
				sccb();
			}
			
			return false;
		}
	}
}
