﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 05.03.2019
 * Time: 23:19
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Linq;

namespace RIMMSqol.extensions
{
	/// <summary>
	/// Description of Extension_IEnumerable.
	/// </summary>
	public static class Extension_IEnumerable
	{
		public static IEnumerable<T> ScrambleByWeight<T>(this IEnumerable<T> source, Func<T, float> weightSelector) {
			if ( source == null ) return Enumerable.Empty<T>();
			List<T> list = new List<T>(source);
			List<T> weightedList = new List<T>(list.Count);
			float totalWeight = 0;
			for ( int i = 0; i < list.Count; i++ ) {
				totalWeight += weightSelector(list[i]);
			}
			while ( list.Count > 0 ) {
				float pickedWeight = totalWeight * UnityEngine.Random.value;
				int i = 0;
				for ( ; i < list.Count; i++ ) {
					T epei = list[i];
					float weight = weightSelector(epei);
					if ( weight >= pickedWeight ) {
						weightedList.Add(epei);
						totalWeight -= weight;
						break;
					}
					pickedWeight -= weight;
				}
				if ( i < list.Count ) {
					list.RemoveAt(i);
				} else {
					//failed to find an entry to remove
					weightedList.Add(list[0]);
					totalWeight -= weightSelector(list[0]);
					list.RemoveAt(0);
				}
			}
			return weightedList;
		}
	}
}
