﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 03.01.2020
 * Time: 03:41
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using Verse;

namespace RIMMSqol.genericSettings
{
	/// <summary>
	/// Description of CombatExtendedConnectors.
	/// </summary>
	static public class CombatExtended_CompProperties_AmmoUser {
		static bool initialized = false;
		static Type tCompPropertiesAmmoUser;
		static MethodInfo miGetCompPropertiesCompPropertiesAmmoUser;
		
		static private Func<CompProperties,int> getterMagazineSize;
		static private Func<CompProperties,float> getterReloadTime;
		static private Func<CompProperties,bool> getterReloadOneAtATime, getterThrowMote/*, getterSpawnUnloaded*/;
		static private Func<CompProperties,Def> getterAmmoSet;
		static private MethodInfo listAmmoSet;
		static private Action<CompProperties,int> setterMagazineSize;
		static private Action<CompProperties,float> setterReloadTime;
		static private Action<CompProperties,bool> setterReloadOneAtATime, setterThrowMote/*, setterSpawnUnloaded*/;
		static private Action<CompProperties,Def> setterAmmoSet;
		
		static void initIfNecessary() {
			if ( !initialized ) {
				tCompPropertiesAmmoUser = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.CompProperties_AmmoUser, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
				miGetCompPropertiesCompPropertiesAmmoUser = tCompPropertiesAmmoUser != null ? typeof(ThingDef).GetMethod("GetCompProperties").MakeGenericMethod(tCompPropertiesAmmoUser) : null;
				if ( tCompPropertiesAmmoUser != null ) {
					getterMagazineSize = UtilReflection.CreateGetter<CompProperties,int>(tCompPropertiesAmmoUser.GetField("magazineSize"));
					getterReloadTime = UtilReflection.CreateGetter<CompProperties,float>(tCompPropertiesAmmoUser.GetField("reloadTime"));
					getterReloadOneAtATime = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("reloadOneAtATime"));
					getterThrowMote = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("throwMote"));
					//getterSpawnUnloaded = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("spawnUnloaded"));
					getterAmmoSet = UtilReflection.CreateGetter<CompProperties,Def>(tCompPropertiesAmmoUser.GetField("ammoSet"));
					Type tAmmoSetDef = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.AmmoSetDef, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
					if ( tAmmoSetDef != null ) listAmmoSet = typeof(DefDatabase<>).MakeGenericType(tAmmoSetDef).GetProperty("AllDefsListForReading").GetGetMethod();
					
					setterMagazineSize = UtilReflection.CreateSetter<CompProperties,int>(tCompPropertiesAmmoUser.GetField("magazineSize"));
					setterReloadTime = UtilReflection.CreateSetter<CompProperties,float>(tCompPropertiesAmmoUser.GetField("reloadTime"));
					setterReloadOneAtATime = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("reloadOneAtATime"));
					setterThrowMote = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("throwMote"));
					//setterSpawnUnloaded = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesAmmoUser.GetField("spawnUnloaded"));
					setterAmmoSet = UtilReflection.CreateSetter<CompProperties,Def>(tCompPropertiesAmmoUser.GetField("ammoSet"));
				}
				initialized = true;
			}
		}
		
		static public CompProperties GetCompProperty(ThingDef td) {
			initIfNecessary();
			if ( td == null || miGetCompPropertiesCompPropertiesAmmoUser == null ) return null;
			return (CompProperties)miGetCompPropertiesCompPropertiesAmmoUser.Invoke(td,null);
		}
			
		static public bool HasCompProperty(ThingDef td) {
			return GetCompProperty(td) != null;
		}
		
		static public int GetMagazineSize(ThingDef td) {
			return GetMagazineSize(GetCompProperty(td));
		}
		
		static public int GetMagazineSize(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterMagazineSize(cp) : default(int);
		}
		
		static public float GetReloadTime(ThingDef td) {
			return GetReloadTime(GetCompProperty(td));
		}
		
		static public float GetReloadTime(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterReloadTime(cp) : 1f;
		}
		
		static public bool GetReloadOneAtATime(ThingDef td) {
			return GetReloadOneAtATime(GetCompProperty(td));
		}
		
		static public bool GetReloadOneAtATime(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterReloadOneAtATime(cp) : default(bool);
		}
		
		static public bool GetThrowMote(ThingDef td) {
			return GetThrowMote(GetCompProperty(td));
		}
		
		static public bool GetThrowMote(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterThrowMote(cp) : true;
		}
		
		/*static public bool GetSpawnUnloaded(ThingDef td) {
			return GetSpawnUnloaded(GetCompProperty(td));
		}*/
		
		/*static public bool GetSpawnUnloaded(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterSpawnUnloaded(cp) : default(bool);
		}*/
		
		static public Def GetAmmoSet(ThingDef td) {
			return GetAmmoSet(GetCompProperty(td));
		}
		
		static public Def GetAmmoSet(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterAmmoSet(cp) : default(Def);
		}
		
		static public IEnumerable<object> ListAmmoSetDef() {
			initIfNecessary();
			if ( listAmmoSet != null ) return ((IEnumerable)listAmmoSet.Invoke(null,null)).Cast<object>();
			return null;
		}
		
		static public void SetMagazineSize(CompProperties cp, int magazineSize) {
			initIfNecessary();
			if ( cp != null ) setterMagazineSize(cp,magazineSize);
		}
		
		static public void SetReloadTime(CompProperties cp, float reloadTime) {
			initIfNecessary();
			if ( cp != null ) setterReloadTime(cp,reloadTime);
		}
		
		static public void SetReloadOneAtATime(CompProperties cp, bool reloadOneAtATime) {
			initIfNecessary();
			if ( cp != null ) setterReloadOneAtATime(cp,reloadOneAtATime);
		}
		
		static public void SetThrowMote(CompProperties cp, bool throwMote) {
			initIfNecessary();
			if ( cp != null ) setterThrowMote(cp,throwMote);
		}
		
		/*static public void SetSpawnUnloaded(CompProperties cp, bool spawnUnloaded) {
			initIfNecessary();
			if ( cp != null ) setterSpawnUnloaded(cp,spawnUnloaded);
		}*/
		
		static public void SetAmmoSet(CompProperties cp, Def def) {
			initIfNecessary();
			if ( cp != null ) setterAmmoSet(cp,def);
		}
	}
	
	static public class CombatExtended_CompProperties_FireModes {
		static bool initialized = false;
		static MethodInfo miGetCompPropertiesCompPropertiesFireModes;
		
		static private Func<CompProperties,int> getterAimedBurstShotCount;
		static private Func<CompProperties,bool> getterAiUseBurstMode, getterNoSingleShot, getterNoSnapshot;
		static private Type tAimMode;
		static private FieldInfo fiAimMode;
		static private Action<CompProperties,int> setterAimedBurstShotCount;
		static private Action<CompProperties,bool> setterAiUseBurstMode, setterNoSingleShot, setterNoSnapshot;
		
		static void initIfNecessary() {
			if ( !initialized ) {
				Type tCompPropertiesFireModes = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.CompProperties_FireModes, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
				miGetCompPropertiesCompPropertiesFireModes = tCompPropertiesFireModes != null ? typeof(ThingDef).GetMethod("GetCompProperties").MakeGenericMethod(tCompPropertiesFireModes) : null;
				if ( tCompPropertiesFireModes != null ) {
					getterAimedBurstShotCount = UtilReflection.CreateGetter<CompProperties,int>(tCompPropertiesFireModes.GetField("aimedBurstShotCount"));
					getterAiUseBurstMode = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("aiUseBurstMode"));
					getterNoSingleShot = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("noSingleShot"));
					getterNoSnapshot = UtilReflection.CreateGetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("noSnapshot"));
					
					tAimMode = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.AimMode, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
					fiAimMode = tCompPropertiesFireModes.GetField("aiAimMode");
					
					setterAimedBurstShotCount = UtilReflection.CreateSetter<CompProperties,int>(tCompPropertiesFireModes.GetField("aimedBurstShotCount"));
					setterAiUseBurstMode = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("aiUseBurstMode"));
					setterNoSingleShot = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("noSingleShot"));
					setterNoSnapshot = UtilReflection.CreateSetter<CompProperties,bool>(tCompPropertiesFireModes.GetField("noSnapshot"));
				}
				initialized = true;
			}
		}
		
		static public CompProperties GetCompProperty(ThingDef td) {
			initIfNecessary();
			if ( td == null || miGetCompPropertiesCompPropertiesFireModes == null ) return null;
			return (CompProperties)miGetCompPropertiesCompPropertiesFireModes.Invoke(td,null);
		}
			
		static public bool HasCompProperty(ThingDef td) {
			return GetCompProperty(td) != null;
		}
		
		static public int GetAimedBurstShotCount(ThingDef td) {
			return GetAimedBurstShotCount(GetCompProperty(td));
		}
		
		static public int GetAimedBurstShotCount(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterAimedBurstShotCount(cp) : default(int);
		}
		
		static public bool GetAiUseBurstMode(ThingDef td) {
			return GetAiUseBurstMode(GetCompProperty(td));
		}
		
		static public bool GetAiUseBurstMode(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterAiUseBurstMode(cp) : default(bool);
		}
		
		static public bool GetNoSingleShot(ThingDef td) {
			return GetNoSingleShot(GetCompProperty(td));
		}
		
		static public bool GetNoSingleShot(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterNoSingleShot(cp) : default(bool);
		}
		
		static public bool GetNoSnapshot(ThingDef td) {
			return GetNoSnapshot(GetCompProperty(td));
		}
		
		static public bool GetNoSnapshot(CompProperties cp) {
			initIfNecessary();
			return cp != null ? getterNoSnapshot(cp) : default(bool);
		}
		
		
		static public string GetAiAimModeAsString(ThingDef td) {
			return GetAiAimModeAsString(GetCompProperty(td));
		}
		
		static public string GetAiAimModeAsString(CompProperties cp) {
			initIfNecessary();
			if ( cp != null ) {
				object o = fiAimMode.GetValue(cp);
				if ( o != null ) return o.ToString();
			}
			return null;
		}
		
		static public IEnumerable<object> ListAiAimModeAsString() {
			return Enum.GetNames(tAimMode).AsEnumerable<object>();
		}
		
		static public void SetAimedBurstShotCount(CompProperties cp, int aimedBurstShotCount) {
			initIfNecessary();
			if ( cp != null ) setterAimedBurstShotCount(cp,aimedBurstShotCount);
		}
		
		static public void SetAiUseBurstMode(CompProperties cp, bool aiUseBurstMode) {
			initIfNecessary();
			if ( cp != null ) setterAiUseBurstMode(cp,aiUseBurstMode);
		}
		
		static public void SetNoSingleShot(CompProperties cp, bool noSingleShot) {
			initIfNecessary();
			if ( cp != null ) setterNoSingleShot(cp,noSingleShot);
		}
		
		static public void SetNoSnapshot(CompProperties cp, bool noSnapshot) {
			initIfNecessary();
			if ( cp != null ) setterNoSnapshot(cp,noSnapshot);
		}
		
		static public void SetAiAimModeAsString(CompProperties cp, string str) {
			initIfNecessary();
			if ( cp != null ) {
				object o;
				try {
					o = Enum.Parse(tAimMode, str);
				} catch { o = null; }
				if ( o != null ) fiAimMode.SetValue(cp,o);
			}
		}
	}

	static public class CombatExtended_VerbPropertiesCE {
		static bool initialized = false;
		static Type tVerbPropertiesCE;
		
		static private Func<VerbProperties,float> getterRecoilAmount, getterIndirectFirePenalty, getterCircularError, getterMeleeArmorPenetration;
		static private Func<VerbProperties,bool> getterEjectsCasings, getterIgnorePartialLoSBlocker;
		static private Type tRecoilPattern;
		static private FieldInfo fiRecoilPattern;
		static private Action<VerbProperties,float> setterRecoilAmount, setterIndirectFirePenalty, setterCircularError, setterMeleeArmorPenetration;
		static private Action<VerbProperties,bool> setterEjectsCasings, setterIgnorePartialLoSBlocker;
		
		static void initIfNecessary() {
			if ( !initialized ) {
				tVerbPropertiesCE = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.VerbPropertiesCE, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
				if ( tVerbPropertiesCE != null ) {
					getterRecoilAmount = UtilReflection.CreateGetter<VerbProperties,float>(tVerbPropertiesCE.GetField("recoilAmount"));
					getterIndirectFirePenalty = UtilReflection.CreateGetter<VerbProperties,float>(tVerbPropertiesCE.GetField("indirectFirePenalty"));
					getterCircularError = UtilReflection.CreateGetter<VerbProperties,float>(tVerbPropertiesCE.GetField("circularError"));
					getterMeleeArmorPenetration = UtilReflection.CreateGetter<VerbProperties,float>(tVerbPropertiesCE.GetField("meleeArmorPenetration"));
					getterEjectsCasings = UtilReflection.CreateGetter<VerbProperties,bool>(tVerbPropertiesCE.GetField("ejectsCasings"));
					getterIgnorePartialLoSBlocker = UtilReflection.CreateGetter<VerbProperties,bool>(tVerbPropertiesCE.GetField("ignorePartialLoSBlocker"));
					
					tRecoilPattern = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.RecoilPattern, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
					fiRecoilPattern = tVerbPropertiesCE.GetField("recoilPattern");
					
					setterRecoilAmount = UtilReflection.CreateSetter<VerbProperties,float>(tVerbPropertiesCE.GetField("recoilAmount"));
					setterIndirectFirePenalty = UtilReflection.CreateSetter<VerbProperties,float>(tVerbPropertiesCE.GetField("indirectFirePenalty"));
					setterCircularError = UtilReflection.CreateSetter<VerbProperties,float>(tVerbPropertiesCE.GetField("circularError"));
					setterMeleeArmorPenetration = UtilReflection.CreateSetter<VerbProperties,float>(tVerbPropertiesCE.GetField("meleeArmorPenetration"));
					setterEjectsCasings = UtilReflection.CreateSetter<VerbProperties,bool>(tVerbPropertiesCE.GetField("ejectsCasings"));
					setterIgnorePartialLoSBlocker = UtilReflection.CreateSetter<VerbProperties,bool>(tVerbPropertiesCE.GetField("ignorePartialLoSBlocker"));
				}
				initialized = true;
			}
		}
			
		static public bool HasVerbProperties(ThingDef td) {
			initIfNecessary();
			return tVerbPropertiesCE != null && td != null && td.Verbs != null && td.Verbs.Count > 0 && tVerbPropertiesCE.IsInstanceOfType(td.Verbs[0]);
		}
		
		static public float GetRecoilAmount(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterRecoilAmount(vp) : default(float);
		}
		
		static public float GetIndirectFirePenalty(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterIndirectFirePenalty(vp) : default(float);
		}
		
		static public float GetCircularError(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterCircularError(vp) : default(float);
		}
		
		static public float GetMeleeArmorPenetration(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterMeleeArmorPenetration(vp) : default(float);
		}
		
		static public bool GetEjectsCasings(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterEjectsCasings(vp) : true;
		}
		
		static public bool GetIgnorePartialLoSBlocker(VerbProperties vp) {
			initIfNecessary();
			return vp != null ? getterIgnorePartialLoSBlocker(vp) : default(bool);
		}
		
		static public string GetRecoilPatternAsString(VerbProperties vp) {
			initIfNecessary();
			if ( vp != null ) {
				object o = fiRecoilPattern.GetValue(vp);
				if ( o != null ) return o.ToString();
			}
			return null;
		}
		
		static public IEnumerable<object> ListRecoilPatternAsString() {
			return Enum.GetNames(tRecoilPattern).AsEnumerable<object>();
		}
		
		static public void SetRecoilAmount(VerbProperties vp, float recoilAmount) {
			initIfNecessary();
			if ( vp != null ) setterRecoilAmount(vp,recoilAmount);
		}
		
		static public void SetIndirectFirePenalty(VerbProperties vp, float indirectFirePenalty) {
			initIfNecessary();
			if ( vp != null ) setterIndirectFirePenalty(vp,indirectFirePenalty);
		}
		
		static public void SetCircularError(VerbProperties vp, float circularError) {
			initIfNecessary();
			if ( vp != null ) setterCircularError(vp,circularError);
		}
		
		static public void SetMeleeArmorPenetration(VerbProperties vp, float meleeArmorPenetration) {
			initIfNecessary();
			if ( vp != null ) setterMeleeArmorPenetration(vp,meleeArmorPenetration);
		}
		
		static public void SetEjectsCasings(VerbProperties vp, bool ejectsCasings) {
			initIfNecessary();
			if ( vp != null ) setterEjectsCasings(vp,ejectsCasings);
		}
		
		static public void SetIgnorePartialLoSBlocker(VerbProperties vp, bool ignorePartialLoSBlocker) {
			initIfNecessary();
			if ( vp != null ) setterIgnorePartialLoSBlocker(vp,ignorePartialLoSBlocker);
		}
		
		static public void SetRecoilPatternAsString(VerbProperties cp, string str) {
			initIfNecessary();
			if ( cp != null ) {
				object o;
				try {
					o = Enum.Parse(tRecoilPattern, str);
				} catch { o = null; }
				if ( o != null ) fiRecoilPattern.SetValue(cp,o);
			}
		}
	}

    static public class CombatExtended_ToolCE
    {
        static bool initialized = false;
        static Type tToolCE;
        static Type tAttachmentDef;

        static private Func<Tool, float> getterArmorPenetrationSharp;
        static private Func<Tool, float> getterArmorPenetrationBlunt;
        static private Func<Tool, Gender> getterRestrictedGender;
        static private Func<Tool, Def> getterRequiredAttachment;
        static private MethodInfo miListAttachmentDefs;
        static private Action<Tool, float> setterArmorPenetrationSharp;
        static private Action<Tool, float> setterArmorPenetrationBlunt;
        static private Action<Tool, Gender> setterRestrictedGender;
        static private Action<Tool, Def> setterRequiredAttachment;

        static void initIfNecessary()
        {
            if (!initialized)
            {
                tToolCE = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.ToolCE, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
                tAttachmentDef = DefSettingsField.GetTypeFromAnyAssemblyVersion("CombatExtended.AttachmentDef, CombatExtended, Version=1.0.1.6, Culture=neutral, PublicKeyToken=null");
                if (tAttachmentDef != null) miListAttachmentDefs = typeof(DefDatabase<>).MakeGenericType(tAttachmentDef).GetProperty("AllDefsListForReading").GetGetMethod();

                if (tToolCE != null)
                {
                    getterArmorPenetrationSharp = UtilReflection.CreateGetter<Tool, float>(tToolCE.GetField("armorPenetrationSharp"));
                    getterArmorPenetrationBlunt = UtilReflection.CreateGetter<Tool, float>(tToolCE.GetField("armorPenetrationBlunt"));
                    getterRestrictedGender = UtilReflection.CreateGetter<Tool, Gender>(tToolCE.GetField("restrictedGender"));
                    getterRequiredAttachment = UtilReflection.CreateGetter<Tool, Def>(tToolCE.GetField("requiredAttachment"));

                    setterArmorPenetrationSharp = UtilReflection.CreateSetter<Tool, float>(tToolCE.GetField("armorPenetrationSharp"));
                    setterArmorPenetrationBlunt = UtilReflection.CreateSetter<Tool, float>(tToolCE.GetField("armorPenetrationBlunt"));
                    setterRestrictedGender = UtilReflection.CreateSetter<Tool, Gender>(tToolCE.GetField("restrictedGender"));
                    setterRequiredAttachment = UtilReflection.CreateSetter<Tool, Def>(tToolCE.GetField("requiredAttachment"));
                }
                initialized = true;
            }
        }

        static public bool IsToolCE(Tool tool)
        {
            initIfNecessary();
            return tool != null && tool.GetType() == tToolCE;
        }

        static public Tool createNewTool()
        {
            initIfNecessary();
            if ( tToolCE != null )
            {
                return (Tool)Activator.CreateInstance(tToolCE);
            }
            return null;
        }

        static public float GetArmorPenetrationSharp(Tool tool)
        {
            initIfNecessary();
            return IsToolCE(tool) ? getterArmorPenetrationSharp(tool) : default(float);
        }

        static public float GetArmorPenetrationBlunt(Tool tool)
        {
            initIfNecessary();
            return IsToolCE(tool) ? getterArmorPenetrationBlunt(tool) : default(float);
        }

        static public Gender GetRestrictedGender(Tool tool)
        {
            initIfNecessary();
            return IsToolCE(tool) ? getterRestrictedGender(tool) : Gender.None;
        }

        static public Def GetRequiredAttachment(Tool tool)
        {
            initIfNecessary();
            return IsToolCE(tool) ? getterRequiredAttachment(tool) : null;
        }

        static public IEnumerable<object> ListAttachmentDef()
        {
            initIfNecessary();
            if (miListAttachmentDefs != null) return ((IEnumerable)miListAttachmentDefs.Invoke(null, null)).Cast<object>();
            return null;
        }

        static public void SetArmorPenetrationSharp(Tool tool, float armorPenetrationSharp)
        {
            initIfNecessary();
            if (IsToolCE(tool)) setterArmorPenetrationSharp(tool, armorPenetrationSharp);
        }

        static public void SetArmorPenetrationBlunt(Tool tool, float armorPenetrationBlunt)
        {
            initIfNecessary();
            if (IsToolCE(tool)) setterArmorPenetrationBlunt(tool, armorPenetrationBlunt);
        }

        static public void SetRestrictedGender(Tool tool, Gender restrictedGender)
        {
            initIfNecessary();
            if (IsToolCE(tool)) setterRestrictedGender(tool, restrictedGender);
        }

        static public void SetRequiredAttachment(Tool tool, Def requiredAttachment)
        {
            initIfNecessary();
            if (IsToolCE(tool)) setterRequiredAttachment(tool, requiredAttachment);
        }
    }
}
