﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using Verse;

namespace RIMMSqol.genericSettings
{
    public class PatchOperation_QoLRemoveProperty : PatchOperation_QoLProperties, IExposable
    {
        public string xpath;
        public XmlContainer value;

        public PatchOperation_QoLRemoveProperty() {}

        public PatchOperation_QoLRemoveProperty(string xpath, string xmlNode) : this()
        {
            this.xpath = xpath;
            XmlDocument doc = new XmlDocument();
            doc.LoadXml(xmlNode);
            value = new XmlContainer();
            value.node = doc.DocumentElement;
        }

        override protected bool ApplyWorker(XmlDocument xml)
        {
            List<string> propertyNames = new List<string>();
            foreach (XmlNode xmlNode in xml.SelectNodes(xpath))
            {
                propertyNames.Clear();
                Dictionary<string, XmlNode> childs = xmlNode.ChildNodes.Cast<XmlNode>().ToDictionary(n => n.Name);
                foreach (XmlNode childNode in value.node.ChildNodes)
                {
                    propertyNames.Add(childNode.Name);
                    XmlNode existingNode;
                    if (childs.TryGetValue(childNode.Name, out existingNode))
                    {
                        xmlNode.RemoveChild(existingNode);
                    }
                }
                MarkPropertiesConfiguredStatus(xmlNode, propertyNames, false);
            }
            return true;
        }

        public void ExposeData()
        {
            Scribe_Values.Look(ref xpath, "xpath");
            Scribe_DirectObjectLoader.Look(ref value, "value");
        }
    }
}
