﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RIMMSqol.genericSettings
{
    static class SettingsDeepLink
    {
        static public ISettingsInstance getSettingsInstance(string categoryId, object baseObject)
        {
            SettingsProperties props = SettingsStorage.getSettingsProperties(categoryId);

            if (props == null || !props.visualization.displayInMenu) return null;
            ISettingsVisualizationSelection visualization = props.visualization as ISettingsVisualizationSelection;
            ISettingsVisualizationSingletonSelection visualizationSingleton = props.visualization as ISettingsVisualizationSingletonSelection;

            ISettingsInstance si;
            if (visualization != null)
            {
                string key = visualization.getKeyFromBaseObject(baseObject);
                List<SettingsInstance> lst = SettingsStorage.GetInstances(props);
                si = lst.Find(siExisting => siExisting.getKey().Equals(key));
                if (si == null)
                {
                    si = new SettingsInstance(props.id, baseObject);
                    lst.Add((SettingsInstance)si);
                }
            }
            else if (visualizationSingleton != null)
            {
                si = SettingsStorage.generateSingletonObject(props);
            }
            else return null;
            return si;
        }
    }
}
