﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 10.10.2018
 * Time: 05:13
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Text;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of NumericAdjustment.
	/// </summary>
	public class NumericAdjustment : IExposable
	{
		public float flat = 0f;
		public float factor = 0f;

		public virtual void ExposeData() {
			Scribe_Values.Look<float>(ref flat,"flat",0f);
			Scribe_Values.Look<float>(ref factor,"factor",0f);
		}
		
		public float Value {
			get { return flat * (1.0f+factor); }
		}
		
		public void Add(NumericAdjustment na) {
			flat += na.flat;
			factor += na.factor;
		}
		
		public void Remove(NumericAdjustment na) {
			flat -= na.flat;
			factor -= na.factor;
		}
		
		public string ToLabeledString(string label) {
			if ( flat != 0 || factor != 0 ) {
				StringBuilder sb = new StringBuilder().Append(label).Append(": ");
				if ( flat != 0 && factor != 0 ) {
					sb.Append(flat.ToString("####.##")).Append(", ").AppendLine(factor.ToString("P0"));
				} else if ( flat != 0 ) {
					sb.AppendLine(flat.ToString("####.##"));
				} else if ( factor != 0 ) {
					sb.AppendLine(factor.ToString("P0"));
				} else {
					sb.AppendLine("0");
				}
				return sb.ToString();
			}
			return String.Empty;
		}
	}
}
