﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 08.10.2018
 * Time: 17:02
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Text;
using RIMMSqol.remnantcolony.listeners;
using RimWorld;
using RimWorld.Planet;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of QOLCityProject.
	/// </summary>
	public class QOLCityProject : IQOLCityListenerOwner, IExposable
	{
		public QOLCityProjectDef def;
		public WorldObject worldObject = null;
		public int timeAdded = -1;
		public float labourInvested = 0;
		public bool active = true;
		public int turnsActive = 0;
		//public List<QOLCityAction> detailActions = new List<QOLCityAction>();
		
		public QOLCityProject() {}
		
		public QOLCityProject(QOLCityProjectDef def) {
			this.def = def;
		}
		
		public System.Collections.Generic.List<QOLCityListenerDef> Listeners { get { return def.listeners; } }

		public void CityContribution(QOLCityState state, bool applyBuildState = false) {
			if ( IsActive ) {
				if ( IsBuilt ) {
					state.Add(def.states.active);
				} else if ( applyBuildState ) {
					state.Add(def.states.build);
				}
				//otherwise build state is applied when/if labour is allocated for the day. 
			} else {
				state.Add(def.states.inactive);
			}
		}
		
		public virtual void ExposeData() {
			Scribe_Defs.Look<QOLCityProjectDef>(ref this.def, "def");
			Scribe_References.Look<WorldObject>(ref this.worldObject, "worldObject");
			Scribe_Values.Look<int>(ref this.timeAdded, "timeAdded");
			Scribe_Values.Look<int>(ref this.turnsActive, "turnsActive");
			Scribe_Values.Look<float>(ref this.labourInvested, "labourInvested");
			Scribe_Values.Look<bool>(ref this.active, "active");
			//Scribe_Collections.Look<QOLCityAction>(ref detailActions, "detailActions");
			
			if (Scribe.mode == LoadSaveMode.PostLoadInit) {
				Init();
			}
		}
		
		public virtual void Init() {
			/*if ( detailActions == null ) detailActions = new List<QOLCityAction>();
			else detailActions.RemoveAll(a=>!def.detailActions.Contains(a.def));
			foreach ( QOLCityActionDef ad in def.detailActions ) {
				if ( !detailActions.Any(a=>a.def == ad) ) {
					detailActions.Add(ad.CreateAction());
				}
			}*/
		}
		
		public void Remove() {
			if ( worldObject != null ) {
				Find.WorldObjects.Remove(worldObject);
			}
		}
		
		public bool IsBuilt {
			get { return labourInvested >= def.labour; }
		}
		
		public bool IsActive {
			get { return active; }
		}
	}
}
