﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 08.01.2019
 * Time: 02:16
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of QOLCityProjectCategoryDef.
	/// </summary>
	public class QOLCityProjectCategoryDef : Def, IComparable<QOLCityProjectCategoryDef>
	{
		[DefaultValue(int.MaxValue), Description("Used to sort this def in relation to other instances of this def. Default order is from low to high.")]
		public int order;
		[DefaultValue(null), Description("How the project should be presented in the cities project list.")]
		public Type renderer;
		
		public int CompareTo(QOLCityProjectCategoryDef def) {
			return order.CompareTo(def.order);
		}
		
		public override IEnumerable<string> ConfigErrors() {
			foreach (string e in base.ConfigErrors()) {
				yield return e;
			}
			if ( renderer == null ) {
				yield return "missing renderer in def of type "+typeof(QOLCityProjectCategoryDef).Name+".";
			}
		}
	}
}
