﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 19.10.2018
 * Time: 23:44
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using RIMMSqol.remnantcolony.listeners;
using RimWorld;
using UnityEngine;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of QOLCityResourceDef.
	/// </summary>
	public class QOLCityResourceDef : QOLCityListenerOwnerDef, IComparable<QOLCityResourceDef> {
		[NoTranslate]
		protected string icon;
		protected Texture2D iconInt;
		public QOLCityCallback callback;
		public Texture2D Icon {
			get {
				if (this.iconInt == null) {
					if (this.icon == null) {
						return null;
					}
					this.iconInt = ContentFinder<Texture2D>.Get(this.icon, false);
					if ( this.iconInt == null ) {
						this.iconInt = (from x in ContentFinder<Texture2D>.GetAllInFolder(this.icon)
							where !x.name.EndsWith(Graphic_Single.MaskSuffix)
							orderby x.name descending
							select x).First();
					}
					if ( this.iconInt == null ) {
						Log.Error("Failed to load a texture from file or folder path \""+this.icon+"\"!");
					}
				}
				return this.iconInt;
			}
		}
		
		[DefaultValue(int.MaxValue), Description("Used to sort this def in relation to other instances of this def. Default order is from low to high.")]
		public int order;
		
		public int CompareTo(QOLCityResourceDef def) {
			return order.CompareTo(def.order);
		}
	}
}
