﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 08.10.2018
 * Time: 15:41
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Text;
using RIMMSqol.remnantcolony.listeners;
using RIMMSqol.extensions;
using RimWorld;
using UnityEngine;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of QOLSocietyIndicatorDef.
	/// </summary>
	public class QOLSocietyIndicatorDef : QOLCityListenerOwnerDef, IComparable<QOLSocietyIndicatorDef>
	{
		[DefaultValue(null), Description("A described and labeled representation for the intensity of the indicator.")]
		public List<QOLSocietyIndicatorStage> stages;
		
		[DefaultValue(int.MaxValue), Description("Used to sort this def in relation to other instances of this def. Default order is from low to high.")]
		public int order;
		
		public int CompareTo(QOLSocietyIndicatorDef def) {
			return order.CompareTo(def.order);
		}
		
		public override void PostLoad() {
			base.PostLoad();
			if ( stages == null ) stages = new List<QOLSocietyIndicatorStage>();
		}
		
		public string Tooltip(Dictionary<QOLSocietyIndicatorStage,float> stageValues, QOLSocietyIndicatorStage currentStage) {
			string s;
			StringBuilder sb = new StringBuilder();
			"Value".TryTranslate(out s);
			sb.Append(s).Append(": ").AppendLine(stageValues[currentStage].ToString("P0"));
			foreach ( KeyValuePair<QOLSocietyIndicatorStage,float> kvp in stageValues ) {
				sb.Append(kvp.Key.label).Append(": ").AppendLine(kvp.Value.ToString("P0"));
			}
			
			return sb.ToString();
		}
	}
	
	public class QOLSocietyIndicatorStage {
		[MustTranslate]
		public string label;
		public string id;
		public QOLCityStateContribution state;

		public void CityContribution(QOLCityState cityState) {
			cityState.Add(state);
		}
	}
}
