﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 17.11.2020
 * Time: 18:41
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using RimWorld;
using RimWorld.Planet;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of WorldObjectCompProperties_CityInteraction.
	/// </summary>
	public class WorldObjectCompProperties_CityInteraction : WorldObjectCompProperties
	{
		public WorldObjectCompProperties_CityInteraction()
		{
			this.compClass = typeof(CityInteractionComp);
		}
	}
	
	public class CityInteractionComp : WorldObjectComp {
		public override System.Collections.Generic.IEnumerable<Verse.Gizmo> GetGizmos()
		{
			QOLCity city = parent as QOLCity;
			if ( city == null ) {
				Log.Error("Type \"" + this.GetType() + "\" is not usable on non city world objects!");
				yield break;
			}
			
			Command_Action command_Action = new Command_Action();
			command_Action.defaultLabel = "CommandManageCity".Translate();
			command_Action.defaultDesc = "CommandManageCityDesc".Translate();
			command_Action.icon = Materials.iconManageCity;
			command_Action.action = delegate { city.TryOpenComms(null); };
			yield return command_Action;
		}
	}
}
