﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 10.02.2021
 * Time: 12:00
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RimWorld;
using RimWorld.Planet;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of WorldObjectCompProperties_SendCaravan.
	/// </summary>
	public class WorldObjectCompProperties_SendCaravan : WorldObjectCompProperties
	{
		public WorldObjectCompProperties_SendCaravan()
		{
			this.compClass = typeof(SendCaravanComp);
		}
	}
	
	public class SendCaravanComp : WorldObjectComp {
		public override System.Collections.Generic.IEnumerable<Verse.Gizmo> GetGizmos()
		{
			QOLCity city = parent as QOLCity;
			if ( city == null ) {
				Log.Error("Type \"" + this.GetType() + "\" is not usable on non city world objects!");
				yield break;
			}
			
			Command_Action command_Action = new Command_Action();
			command_Action.defaultLabel = "CommandFormCaravan".Translate();
			command_Action.defaultDesc = "CommandFormCaravanDesc".Translate();
			command_Action.icon = FormCaravanComp.FormCaravanCommand;
			command_Action.tutorTag = "FormCaravan";
			command_Action.action = delegate { Find.WindowStack.Add(new Dialog_FormCaravanQOL(city, 
                      new List<Pawn>(city.population.citizens.Keys), 
                      new List<Thing>(city.Goods), false, null, false)); };
			yield return command_Action;
		}
	}
}
