﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 13.12.2018
 * Time: 11:17
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using RIMMSqol.remnantcolony.listeners;
using UnityEngine;
using Verse;

namespace RIMMSqol.remnantcolony.actions
{
	/// <summary>
	/// Description of QOLCityActionDef.
	/// </summary>
	public class QOLCityActionDef : QOLCityListenerNonOwnerDef, IComparable<QOLCityActionDef>
	{
		[NoTranslate]
		protected string icon;
		protected Texture2D iconInt;
		[DefaultValue(int.MaxValue), Description("Used to sort this def in relation to other instances of this def. Default order is from low to high.")]
		public int order;
		public QOLCityActionConfiguration action;
		
		public Texture2D Icon {
			get {
				if (this.iconInt == null) {
					if (this.icon == null) {
						return null;
					}
					this.iconInt = ContentFinder<Texture2D>.Get(this.icon, false);
					if ( this.iconInt == null ) {
						this.iconInt = (from x in ContentFinder<Texture2D>.GetAllInFolder(this.icon)
							where !x.name.EndsWith(Graphic_Single.MaskSuffix)
							orderby x.name descending
							select x).First();
					}
					if ( this.iconInt == null ) {
						Log.Error("Failed to load a texture from file or folder path \""+this.icon+"\"!");
					}
				}
				return this.iconInt;
			}
		}
		
		public int CompareTo(QOLCityActionDef def) {
			return order.CompareTo(def.order);
		}
		
		public QOLCityAction CreateAction() {
			return action.CreateAction(this);
		}
	}
	
	public abstract class QOLCityActionConfiguration {
		public abstract QOLCityAction CreateAction(QOLCityActionDef def);
	}
}
