﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 10.02.2019
 * Time: 17:41
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RIMMSqol.renderers;
using Verse;

namespace RIMMSqol.remnantcolony.actions
{
	/// <summary>
	/// Description of QOLCityAction_CitySettings.
	/// </summary>
	public class QOLCityAction_CitySettings : QOLCityAction
	{
		public QOLCityAction_CitySettings() : base(null) {}
		
		public QOLCityAction_CitySettings(QOLCityActionDef def) : base(def) {}
		
		public override void OnClick(QOLCity city, Pawn negotiator) {
			if ( city != null ) {
				Dictionary<string, PageRenderer> pages = new Dictionary<string, PageRenderer>();
				PageRenderer prOverview = new PageRenderer(f=>"", null, null, null);
				prOverview.AddChild(
					new RowLayoutRenderer()
					.AddChild(new ColumnLayoutRenderer()
					        .AddChild(new LabelRenderer("Name".Translate(), 200f, GameFont.Medium))
				            .AddChild(new EditTextRenderer(f=>((QOLCity)f.flowScope["city"]).cityName,(f,v) => ((QOLCity)f.flowScope["city"]).cityName = v,200f)))
					.AddChild(new ColumnLayoutRenderer()
					          .AddChild(new LabelRenderer("Interval".Translate(), 200f, GameFont.Medium))
					          .AddChild(new EditNumericRenderer<int>(f=>((QOLCity)f.flowScope["city"]).simulationInterval,
					                                                 (f,v) => ((QOLCity)f.flowScope["city"]).simulationInterval = v,200f,1f)))
					.AddChild(new ButtonTextRenderer("Delete".Translate(), f => Find.WindowStack.Add(new Dialog_MessageBox("This will remove the city and cannot be reversed!", "Delete".Translate(), 
					                                                                                                       () => f.addPostRenderCallback(fl => ((QOLCity)fl.flowScope["city"]).Remove()), 
					                                                                                                       "CancelButton".Translate(), null, 
					                                                                                                       "Warning".Translate().ToString().ToUpper(), true, null, null)), GameFont.Medium))
				);
				
				pages.Add("settings",prOverview);
				
				Flow flow = new Flow(pages,"settings");
				
				flow.flowScope["city"] = city;
				flow.flowScope["negotiator"] = negotiator;
				Find.WindowStack.Add(new Dialog_Flow(flow,440f,180f));
			} else {
				Log.Error("City was null in "+this.GetType().Name+"!");
			}
		}
	}
	
	public class QOLCityActionConfiguration_CitySettings : QOLCityActionConfiguration {
		public override QOLCityAction CreateAction(QOLCityActionDef def) {
			return new QOLCityAction_CitySettings(def);
		}
	}
}
