﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 15.01.2019
 * Time: 10:50
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using Verse;

namespace RIMMSqol.remnantcolony.listeners
{
	/// <summary>
	/// Description of QOLCityListenerDef.
	/// </summary>
	public class QOLCityListenerDef : Def
	{
		public List<EventProcessingProperties> eventIds;
		public Type listenerClass;
		
		public QOLCityListener CreateListener(IQOLCityListenerOwner owner) {
			if ( listenerClass != null ) {
				return (QOLCityListener)Activator.CreateInstance(listenerClass, new object[]{this,owner});
			}
			
			return null;
		}
		
		public class EventProcessingProperties : IComparable<EventProcessingProperties> {
			public string eventId;
			public int order = int.MaxValue;
			
			public int CompareTo(EventProcessingProperties def) {
				return order.CompareTo(def.order);
			}
		}
	}
	
	public interface IQOLCityListenerOwner {
		List<QOLCityListenerDef> Listeners{get;}
	}
	
	public abstract class QOLCityListenerNonOwnerDef : Def {
		public List<QOLCityListenerDef> listeners;
	}
	
	public abstract class QOLCityListenerOwnerDef : QOLCityListenerNonOwnerDef, IQOLCityListenerOwner {
		public List<QOLCityListenerDef> Listeners {
			get { return listeners; }
		}
	}
}
