﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 18.02.2021
 * Time: 09:12
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RIMMSqol.translations;
using RimWorld;
using Verse;

namespace RIMMSqol.remnantcolony.pawnvalues
{
	/// <summary>
	/// Description of QOLCityPawnValue_HungerRate.
	/// </summary>
	public class QOLCityPawnValue_HungerRate : QOLCityPawnValue {
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public float Value(QOLCityState state, Pawn p) {
			return p.ageTracker.CurLifeStage.hungerRateFactor * p.RaceProps.baseHungerRate * 
				p.health.hediffSet.HungerRateFactor * ((p.story == null || p.story.traits == null) ? 1f : p.story.traits.HungerRateFactor) * 
				p.GetStatValue(StatDefOf.HungerRateMultiplier, true);
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityPawnValue_HungerRate).Name);
			}
			return translationRequestDescription;
		}
	}
}
