﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 28.02.2019
 * Time: 04:56
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RIMMSqol.remnantcolony.listeners;
using Verse;

namespace RIMMSqol.remnantcolony.projects
{
	/// <summary>
	/// Description of QOLCityProject_EventProducer.
	/// </summary>
	public class QOLCityProject_EventProducer : QOLCityProject, IEventProducerOwner {
		protected Dictionary<string, DictionaryExposable<string, int>> eventProducerCooldownsInt = new Dictionary<string, DictionaryExposable<string, int>>();
		
		public QOLCityProject_EventProducer() : base() {}
		
		public QOLCityProject_EventProducer(QOLCityProjectDef def) : base(def) {}
		
		public override void ExposeData() {
			base.ExposeData();
			Scribe_Collections.Look<string, DictionaryExposable<string, int>>(ref this.eventProducerCooldownsInt, "eventProducerCooldowns", LookMode.Value, LookMode.Deep);
			if (Scribe.mode == LoadSaveMode.PostLoadInit) {
				if ( this.eventProducerCooldownsInt == null ) this.eventProducerCooldownsInt = new Dictionary<string, DictionaryExposable<string, int>>();
			}
		}

		public Dictionary<string, DictionaryExposable<string, int>> eventProducerCooldowns {
			get {
				return eventProducerCooldownsInt;
			}
			set {
				if ( value != null ) eventProducerCooldownsInt = value;
				else eventProducerCooldowns = new Dictionary<string, DictionaryExposable<string, int>>();
			}
		}
	}
}
