﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 16.05.2019
 * Time: 23:21
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using RIMMSqol.remnantcolony.projects;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.requirements
{
	/// <summary>
	/// Description of QOLCityRequirement_CrisisProgressIsBelow.
	/// </summary>
	public class QOLCityRequirement_CrisisProgressIsBelow : QOLCityRequirement {
		/// <summary>
		/// Crisis project to check the progress of.
		/// </summary>
		public QOLCityProjectDef crisis = null;
		/// <summary>
		/// The value must be lower than the progress on the crisis.
		/// </summary>
		public float value;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public bool IsValid(QOLCity city) {
			QOLCityProject_Crisis proj = city.projects.Find(p=>p.def == crisis) as QOLCityProject_Crisis;
			if ( proj == null ) {
				Log.Error("Failed to find crisis project "+proj.def.defName+" on city for project requirement "+typeof(QOLCityRequirement_CrisisProgressIsBelow).Name+"!");
				return false;
			}
			return proj.progress < value;
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityRequirement_CrisisProgressIsBelow).Name, new[]{"crisis","value"}, new object[]{crisis.label,value});
			}
			return translationRequestDescription;
		}
	}
}
