﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 15.02.2019
 * Time: 12:05
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.requirements
{
	/// <summary>
	/// Description of QOLCityRequirement_Or.
	/// </summary>
	public class QOLCityRequirement_Or : QOLCityRequirement
	{
		public List<QOLCityRequirement> requirements;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public bool IsValid(QOLCity city) {
			return requirements.Any(r=>r.IsValid(city));
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				StringBuilder sb = new StringBuilder();
				foreach ( QOLCityRequirement req in requirements ) {
					if ( sb.Length > 0 ) sb.Append(", ");
					sb.Append("[").Append(req.Description()).Append("]");
				}
				translationRequestDescription = new TranslationRequest(typeof(QOLCityRequirement_Or).Name, new[]{"requirements"}, new object[]{sb.ToString()});
			}
			return translationRequestDescription;
		}
	}
}
