﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 05.02.2019
 * Time: 05:13
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.requirements
{
	/// <summary>
	/// Tests if the total population count is within the min max boundaries.
	/// </summary>
	public class QOLCityRequirement_PopulationCount : QOLCityRequirement {
		/// <summary>
		/// The population count must be at least this high.
		/// </summary>
		public int min = 0;
		/// <summary>
		/// The population count must be at most this high.
		/// </summary>
		public int max = int.MaxValue;
		
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public bool IsValid(QOLCity city) {
			return min <= city.population.citizens.Count && city.population.citizens.Count <= max;
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityRequirement_PopulationCount).Name, new[]{"min","max"}, new object[]{min,max});
			}
			return translationRequestDescription;
		}
	}
}
