﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 06.12.2019
 * Time: 05:34
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using HarmonyLib;
using Verse;

namespace RIMMSqol.storyteller
{
	/// <summary>
	/// Description of MapDeiniter_Deinit.
	/// </summary>
	[HarmonyPatch(typeof(MapDeiniter))]
	[HarmonyPatch("Deinit")]
	[HarmonyPatchNamespace("Storyteller")]
	static public class MapDeiniter_Deinit
	{
		[HarmonyPriority(Priority.Last)]
		static void Postfix(Map map)
		{
			StorytellerGameComponent stgc = Current.Game.GetComponent<StorytellerGameComponent>();
			if ( stgc != null ) {
				try {
					stgc.MapRemoved(map);
				} catch (Exception ex) {
					Log.Error("Error while deiniting map: Failed to inform RIMMSQol storyteller! " + ex);
				}
			}
		}
	}
}
