﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 19.11.2019
 * Time: 14:19
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RimWorld;

namespace RIMMSqol.storyteller
{
	/// <summary>
	/// Description of StorytellerTreeIncident.
	/// </summary>
	public class StorytellerTreeIncident
	{
		public FiringIncident incident;
		public int delay, retryDurationTicks;
		public List<Action<StorytellerTreeIncident,StorytellerTree>> OnFiredOrQueued;
		
		public StorytellerTreeIncident(FiringIncident incident) : this(incident, 0, 0) { }
		
		public StorytellerTreeIncident(FiringIncident incident, int delay, int retryDurationTicks) {
			this.incident = incident;
			this.delay = delay;
			this.retryDurationTicks = retryDurationTicks;
		}
		
		public void ListenToFiredOrQueued(Action<StorytellerTreeIncident,StorytellerTree> listener) {
			if ( OnFiredOrQueued == null ) OnFiredOrQueued = new List<Action<StorytellerTreeIncident, StorytellerTree>>();
			OnFiredOrQueued.Add(listener);
		}
		
		public void NotifyFiredOrQueued(StorytellerTree tree) {
			if ( OnFiredOrQueued != null ) {
				foreach ( Action<StorytellerTreeIncident, StorytellerTree> listener in OnFiredOrQueued ) {
					listener(this,tree);
				}
			}
		}
		
		public void Dispose() {
			if ( OnFiredOrQueued != null ) OnFiredOrQueued.Clear();
			OnFiredOrQueued = null;
			incident = null;
		}
	}
}
